#!/usr/bin/python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License                *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#*************************************************************************** 

import base64
import os

from campos import *
from frminsertar import *


class insertar(QtGui.QDialog):

	def __init__(self, parent=None):
		
		QtGui.QWidget.__init__(self, parent)
		self.ui = Ui_frminsertar()
		self.ui.setupUi(self)
		

	def cerrar(self):
		self.close()

	def llenar(self, frmparent):
		
		self.frmParent = frmparent
		self.ui.btnInsertar.setHidden(0)
		self.ui.btnModificar.setHidden(1)
		self.ui.btnEliminar.setHidden(1)
		self.DatosNuevaCaratula = ''
		
		imgPelicula_Data= QtGui.QPixmap('./icons/smoviedb.png')
		self.ui.imgPelicula.setPixmap(imgPelicula_Data)


		self.campos = Campos(self.dbconn)
		self.campos.llenaddlGenero(self.ui.ddlGenero)
		self.campos.llenaddlTipo(self.ui.ddlTipo)
		self.campos.llenaddlFormato(self.ui.ddlFormato)
		#self.campos.llenaddlAnio(self.ui.ddlAnio)
		self.campos.llenaddlLocalizacion(self.ui.ddlLocalizacion)
		self.campos.llenaddlValoracion(self.ui.ddlValoracion)

		self.campos.InsertaIcono(self.ui.btnCancelar, "dialog-close")
		self.campos.InsertaIcono(self.ui.btnInsertar, "document-save")
		self.campos.InsertaIcono(self.ui.btnModificar, "document-save")
		self.campos.InsertaIcono(self.ui.btnEliminar, "edit-delete")
	
		self.show()

	def cargar(self, frmparent,id_pelicula):
		self.llenar(frmparent)
		self.ui.btnInsertar.setHidden(1)
		self.ui.btnModificar.setHidden(0)
		self.ui.btnEliminar.setHidden(0)

		sql = "SELECT * from peliculas where id = "+str(id_pelicula)
		self.dbconn.execute(sql)
		peli_row = self.dbconn.fetchall()
		self.id= peli_row[0][0]
		self.ui.txtNombre.setText(peli_row[0][1])
		self.ui.txtAnio.setText(peli_row[0][5])
		self.ui.txtTamanio.setText(peli_row[0][6])
		self.ui.txtOpinion.setText(peli_row[0][8])
		#Desplegables
		try: 
			self.ui.ddlGenero.setCurrentIndex(self.campos.generos_id[int(peli_row[0][2])]);
		except:
			#print "No encontrado el genero para posicionar"
			self.error = 1
			
		try:
			self.ui.ddlTipo.setCurrentIndex(self.campos.tipos_id[int(peli_row[0][3])])
		except:
			#print "No encontrado el tipo para posicionar"
			self.error = 1
			
		try:
			self.ui.ddlFormato.setCurrentIndex(self.campos.formatos_id[int(peli_row[0][4])])
		except:	
			#print "No encontrado el formato para posicionar"
			self.ui.error = 1
			
		try:
			self.ui.ddlLocalizacion.setCurrentIndex(self.campos.localizaciones_id[int(peli_row[0][7])])
		except:
			#print "No encontrada la localizacion para posicionar"
			self.error = 1
			
		try:
			self.ui.ddlValoracion.setCurrentIndex(int(peli_row[0][9])+1)			
		except:
			#print "No encontrada la valoracion para posicionar"
			self.error = 1
			
		# hay imágen de carátula:
		
		try:
			sql2 = "SELECT datos from caratulas where id_pelicula = "+str(id_pelicula)
			self.dbconn.execute(sql2)
			res = self.dbconn.fetchall()
			
			for c_row in res:
				
				imgPelicula_Data= QtGui.QPixmap()
				imgPelicula_Data.loadFromData(base64.b64decode(c_row[0]),"JPEG")
				self.ui.imgPelicula.setPixmap(imgPelicula_Data)
			
		except:
			
			
			try:
				#probamos a crear la tabla de caratulas, por si es una versión anterior y no existia
				try:
					sql = "CREATE TABLE caratulas (datos BLOB, id_pelicula INTEGER PRIMARY KEY)"
					self.dbconn.execute(sql)
				except:
					return 0
				#si no ha fallado intentamos cargar de nuevo la caratula
				cargar(self, frmparent,id_pelicula)
				return 0
			except:
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al cargar la carátula'))	
		
		return

	def cambiarCaratula(self):
		
		str_file = QtGui.QFileDialog.getOpenFileName(self,self.__tr("sMovieDB - Insertar Carátula"),os.environ["HOME"],self.__tr("Imagen JPEG (*.jpg)") );
		if (len(str_file) > 0):
			try:
				file = open(str_file,'rb')	
				imgPelicula_Data= QtGui.QPixmap()
				data = file.read()
				file.close()
			except:
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al cargar el archivo'))
				return 0
				
			if (len(data) / 1024) > 33:				
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('La imagen JPG no puede superar los 30 Kb de tamaño.'))
				return 0
			
			imgPelicula_Data.loadFromData(data,"JPEG")		
			
			
			self.ui.imgPelicula.setPixmap(imgPelicula_Data)
			self.DatosNuevaCaratula = data
		

	def insertar(self):

		self.setCursor(QtGui.QCursor(QtCore.Qt.WaitCursor))
		sql = "INSERT INTO peliculas VALUES (NULL , "
	

		try: 
			sql = sql+" '"+self.frmParent.codifica(self.ui.txtNombre.text())+"', "
		except: sql = sql+" '',"
		try: 
			sql = sql+" '"+str(self.campos.generos_pos[self.ui.ddlGenero.currentIndex()]) + "', "
		except: sql = sql+" '',"
		try: 
			sql = sql+" '"+str(self.campos.tipos_pos[self.ui.ddlTipo.currentIndex()]) +"',"
		except: sql = sql+" '',"
		try: 
			sql = sql+" '"+str(self.campos.formatos_pos[self.ui.ddlFormato.currentIndex()]) +"', "
		except: sql = sql+" '',"
		try: 
			sql = sql+" '"+self.frmParent.codifica(self.ui.txtAnio.text())+"', "
		except: sql = sql+" '',"
		try: 
			sql = sql+" '"+self.frmParent.codifica(self.ui.txtTamanio.text())+"', "
		except: sql = sql+" '',"
		try: 
			sql = sql+" '"+str(self.campos.localizaciones_pos[self.ui.ddlLocalizacion.currentIndex()]) +"', "
		except: sql = sql+" '',"
		try: 
			sql = sql+" '" + self.frmParent.codifica(self.ui.txtOpinion.toPlainText()) + "', "
		except: sql = sql+" '',"
		try: 
			sql = sql+" '" + str(self.ui.ddlValoracion.currentIndex()-1) + "', "
		except: sql = sql+" '',"
		sql = sql + "0)"
				
		try:
			self.dbconn.execute(str(sql))
			
			try:
				if len(self.DatosNuevaCaratula)>0:
					sql4 = "SELECT max(id) from peliculas"
					self.dbconn.execute(str(sql4))
					ultimo_id = self.dbconn.fetchall()
					
					sql2 = "DELETE FROM caratulas WHERE id_pelicula = " + str(ultimo_id[0][0])
					sql3 = "INSERT INTO caratulas (id_pelicula, datos) VALUES ('" + str(ultimo_id[0][0]) + "', '"+ base64.b64encode(self.DatosNuevaCaratula) +"')"
					
					
					
					self.dbconn.execute(str(sql2))
					self.dbconn.execute(str(sql3))
			except:

				try:
					#probamos a crear la tabla de caratulas, por si es una versi�n anterior y no exist�a
					try:
						sql = "CREATE TABLE caratulas (datos BLOB, id_pelicula INTEGER PRIMARY KEY)"
						self.dbconn.execute(sql2)
					except:
						QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardar la carátula'))
						self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
						return 0
					#si no ha fallado intentamos cargar de nuevo la caratula
					cargar(self, frmparent,id_pelicula)
					return 0
				except:
					QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardar la carátula'))
					self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
			try:
				self.dbconn.execute('commit;');
			except:
				self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
		except:
			QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al insertar la película'))
			print sql
			self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
			return
		
		self.frmParent.pintaTablaCatalogo(0)
		self.frmParent.pintaArbolCatalogo()
		self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
		self.cerrar()
		return

	def modificar(self):
		
		self.setCursor(QtGui.QCursor(QtCore.Qt.WaitCursor))
		sql = "UPDATE peliculas set "
		try: 
			sql = sql+"nombre='"+self.frmParent.codifica(self.ui.txtNombre.text())+"', "
		except: error=1
		try: 
			sql = sql+"genero='"+str(self.campos.generos_pos[self.ui.ddlGenero.currentIndex()]) + "', "
		except: error=1
		try: 
			sql = sql+"tipo='"+str(self.campos.tipos_pos[self.ui.ddlTipo.currentIndex()]) +"',"
		except: error=1
		try: 
			sql = sql+"formato='"+str(self.campos.formatos_pos[self.ui.ddlFormato.currentIndex()]) +"', "
		except: error=1
		try: 
			sql = sql+"anio='"+self.frmParent.codifica(self.ui.txtAnio.text())+"', "
		except: error=1
		try: 
			sql = sql+"tamanio='"+self.frmParent.codifica(self.ui.txtTamanio.text())+"', "
		except: error=1
		try: 
			sql = sql+"localizacion='"+str(self.campos.localizaciones_pos[self.ui.ddlLocalizacion.currentIndex()]) +"', "
		except: error=1
		try: 
			sql = sql+"opinion='" + self.frmParent.codifica(self.ui.txtOpinion.toPlainText()) + "', "
		except: error=1
		try: 
			sql = sql+"valoracion='" + str(self.ui.ddlValoracion.currentIndex()-1) + "' "
		except: error=1
		sql = sql+" WHERE id="+str(self.id)
		
		
		
		try:
			self.dbconn.execute(str(sql))
			
			try:
				if len(self.DatosNuevaCaratula)>0:
			
					sql2 = "DELETE FROM caratulas WHERE id_pelicula = " + str(self.id)
					sql3 = "INSERT INTO caratulas (id_pelicula, datos) VALUES ('" + str(self.id) + "', '"+ base64.b64encode(self.DatosNuevaCaratula) +"')"
					
					self.dbconn.execute(str(sql2))
					self.dbconn.execute(str(sql3))
			except:
				self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardar la carátula'))
				#print sql2
				#print sql3
			
			try:
				self.dbconn.execute('commit;');
			except:
				self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
				error=1
		except:
			QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al modificar la película'))
			print sql
			self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
			return
			
		
		
			
		self.frmParent.pintaTablaCatalogo(0)
		self.frmParent.pintaArbolCatalogo()
		self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
		self.cerrar()

		return

	def eliminar(self):

		self.setCursor(QtGui.QCursor(QtCore.Qt.WaitCursor))
		sql = "UPDATE peliculas set borrado = 1 where id = "+str(self.id)
		#print sql
		try:
			self.dbconn.execute(str(sql))
			try:
				self.dbconn.execute('commit;');
			except:
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al eliminar la película'))
				self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
				return
		except:
			QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al eliminar la película'))
			print sql
			self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
			return

		self.frmParent.pintaTablaCatalogo(0)
		self.frmParent.pintaArbolCatalogo()
		self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
		self.cerrar()
		return

	def __tr(self, texto):
		return QtGui.QApplication.translate("frminsertar", texto, None, QtGui.QApplication.UnicodeUTF8)
