#!/usr/bin/python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License         *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

from frmpreferencias import *
import os

class preferencias(QtGui.QDialog):

	def __init__(self, parent=None):
		
		QtGui.QWidget.__init__(self, parent)
		self.ui = Ui_frmPreferencias()
		self.ui.setupUi(self)
		self.ui.tabWidget2.setCurrentIndex(0)
		
		
	def onload(self,parent):
		self.frmParent = parent

		self.ui.txtHost.setText(self.frmParent.conf.LeeConfiguracion('host'))
		self.ui.txtUser.setText(self.frmParent.conf.LeeConfiguracion('user'))
		self.ui.txtPassword.setText(self.frmParent.conf.LeeConfiguracion('pass'))
		self.ui.txtDbname.setText(self.frmParent.conf.LeeConfiguracion('dbname'))

		if self.frmParent.conf.LeeConfiguracion('autoconnect') == "1":
			self.ui.chkAutoconectar.setCheckState(2)			
		else:
			self.ui.chkAutoconectar.setCheckState(0)
		
		if (self.frmParent.conf.LeeConfiguracion('dbtype') == 'mysql'):
			self.ui.ddlTipoBaseDatos.setCurrentIndex(1)
			self.ddlTipoBaseDatos_change(1)

		if self.frmParent.conectado == 1:
			self.dbconn = self.frmParent.dbconn
			#Llena
			self.llenaGeneros()
			self.llenaTipos()
			self.llenaLocalizaciones()
			self.llenaFormatos()
			#Arrays para los eliminados
			self.generos_eliminados=[]
			self.formatos_eliminados=[]
			self.localizaciones_eliminadas=[]
			self.tipos_eliminados=[]
		else:
			self.ui.tabWidget2.setTabEnabled(1,0)
			self.ui.tabWidget2.setTabEnabled(2,0)
			self.ui.tabWidget2.setTabEnabled(3,0)
			self.ui.tabWidget2.setTabEnabled(4,0)
		self.conectores()
		self.show()

	def conectores(self):
		QtCore.QObject.connect(self.ui.lstFormatos, QtCore.SIGNAL("itemClicked(QListWidgetItem*)"), self.lstFormatos_click)
		QtCore.QObject.connect(self.ui.lstGeneros, QtCore.SIGNAL("itemClicked(QListWidgetItem*)"), self.lstGeneros_click)
		QtCore.QObject.connect(self.ui.lstTipos, QtCore.SIGNAL("itemClicked(QListWidgetItem*)"), self.lstTipos_click)
		QtCore.QObject.connect(self.ui.lstLocalizaciones, QtCore.SIGNAL("itemClicked(QListWidgetItem*)"), self.lstLocalizaciones_click)

	def __tr(self, texto):
		return QtGui.QApplication.translate("frmPreferencias", texto, None, QtGui.QApplication.UnicodeUTF8)

	def aceptar(self):

		self.frmParent.conf.GuardaConfiguracion('host', self.ui.txtHost.text())
		self.frmParent.conf.GuardaConfiguracion('user', self.ui.txtUser.text())
		self.frmParent.conf.GuardaConfiguracion('pass', self.ui.txtPassword.text())
		self.frmParent.conf.GuardaConfiguracion('dbname', self.ui.txtDbname.text())
		self.frmParent.conf.GuardaConfiguracion('autoconnect', int(bool( self.ui.chkAutoconectar.checkState())))
		if (self.ui.ddlTipoBaseDatos.currentIndex() == 0):
			self.frmParent.conf.GuardaConfiguracion('dbtype', 'sqlite')
		else:
			self.frmParent.conf.GuardaConfiguracion('dbtype', 'mysql')
		self.frmParent.conf.GuardarFichero()

		if self.frmParent.conectado == 0:
			self.close()
			return


		#__Guardar datos de formatos
		
		for formato in self.frmParent.campos.formatos:
			
			if str(formato)[0] == "n":
				#Esto es un elemento nuevo,insertamos
				sql = "INSERT INTO formatos (id,nombre,borrado) VALUES (NULL,'"+self.frmParent.campos.formatos[formato]+"',0)"
			else:
				#Esto es un elemento existente,actualizamos
				sql = "UPDATE formatos SET nombre = '"+self.frmParent.campos.formatos[formato]+"' WHERE id="+str(formato)
			try:
				self.dbconn.execute(sql)
			except:
				print "Error al guardar los formatos: "+sql
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		
		for formato_eliminado in self.formatos_eliminados:
			if str(formato_eliminado)[0] != "n":
				sql = "UPDATE formatos SET borrado = 1 WHERE id="+str(formato_eliminado)
				try:
					self.dbconn.execute(sql)
				except:
					print "Error al guardar los formatos: "+sql
					QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))


		#__Guardar datos de géneros
		
		for genero in self.frmParent.campos.generos:
			
			if str(genero)[0] == "n":
				#Esto es un elemento nuevo,insertamos
				sql = "INSERT INTO generos (id,nombre,borrado) VALUES (NULL,'"+self.frmParent.campos.generos[genero]+"',0)"
			else:
				#Esto es un elemento existente,actualizamos
				sql = "UPDATE generos SET nombre = '"+self.frmParent.campos.generos[genero]+"' WHERE id="+str(genero)
			try:
				self.dbconn.execute(str(sql))
			except:
				print "Error al guardar los generos: "+sql
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		for genero_eliminado in self.generos_eliminados:
			if str(genero_eliminado)[0] != "n":
				sql = "UPDATE generos SET borrado = 1 WHERE id="+str(genero_eliminado)
				try:
					self.dbconn.execute(sql)
				except:
					print "Error al guardar los generos: "+sql
					QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))

		
		#__Guardar datos de Tipos
		
		for tipo in self.frmParent.campos.tipos:
			
			if str(tipo)[0] == "n":
				#Esto es un elemento nuevo,insertamos
				sql = "INSERT INTO tipos (id,nombre,borrado) VALUES (NULL,'"+self.frmParent.campos.tipos[tipo]+"',0)"
			else:
				#Esto es un elemento existente,actualizamos
				sql = "UPDATE tipos SET nombre = '"+self.frmParent.campos.tipos[tipo]+"' WHERE id="+str(tipo)
			try:
				self.dbconn.execute(sql)
			except:
				print "Error al guardar los Tipos: "+sql
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		for tipo_eliminado in self.tipos_eliminados:
			if str(tipo_eliminado)[0] != "n":
				sql = "UPDATE tipos SET borrado = 1 WHERE id="+str(tipo_eliminado)
				try:
					self.dbconn.execute(sql)
				except:
					print "Error al guardar los tipos: "+sql
					QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		

		#__Guardar datos de Localizaciones
		
		for localizacion in self.frmParent.campos.localizaciones:
			
			if str(localizacion)[0] == "n":
				#Esto es un elemento nuevo,insertamos
				sql = "INSERT INTO localizaciones (id,nombre,borrado) VALUES (NULL,'"+self.frmParent.campos.localizaciones[localizacion]+"',0)"
			else:
				#Esto es un elemento existente,actualizamos
				sql = "UPDATE localizaciones SET nombre = '"+self.frmParent.campos.localizaciones[localizacion]+"' WHERE id="+str(localizacion)
			try:
				self.dbconn.execute(sql)
			except:
				print "Error al guardar las Localizaciones: "+sql
				QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		for localizacion_eliminada in self.localizaciones_eliminadas:
			
			if str(localizacion_eliminada)[0] != "n":
				sql = "UPDATE localizaciones SET borrado = 1 WHERE id='"+str(localizacion_eliminada)+"'"
				try:
					self.dbconn.execute(sql)
				except:
					print "Error al guardar los tipos: "+sql
					QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
					

		self.frmParent.db.commit()
		self.frmParent.conectar()
		self.close()

		return

	def ddlTipoBaseDatos_change(self, n):
		if (n==1):
			self.ui.grpMysql.setEnabled(1)
		else:
			self.ui.grpMysql.setEnabled(0)

	#___________________________________________________________________________________
	#	Formatos
	
	def llenaFormatos(self):
		self.frmParent.campos.llenaddlFormato(self.ui.lstFormatos,'lst')

	def eliminarFormatos(self):
		#print self.frmParent.campos.formatos
		#print self.ui.lstFormatos.currentRow()+1
		#print self.frmParent.campos.formatos_pos[self.ui.lstFormatos.currentRow()+1]
		
		if self.ui.lstFormatos.currentRow()>=0:
			self.formatos_eliminados.append(self.frmParent.campos.formatos_pos[self.ui.lstFormatos.currentRow()+1])
			del self.frmParent.campos.formatos[self.frmParent.campos.formatos_pos[self.ui.lstFormatos.currentRow()+1]]
			self.ui.lstFormatos.takeItem(self.ui.lstFormatos.currentRow())
			self.ui.txtEditarFormato.setText("")

		#print self.formatos_eliminados
		return
	
	def nuevoFormato(self):

		if self.ui.txtCrearFormato.text().length()>0:
			self.ui.lstFormatos.addItem(self.ui.txtCrearFormato.text())
			self.frmParent.campos.formatos['n'+self.frmParent.codifica(self.ui.txtCrearFormato.text())] = self.frmParent.codifica(self.ui.txtCrearFormato.text())			
			self.frmParent.campos.formatos_pos[self.ui.lstFormatos.count()]='n'+self.frmParent.codifica(self.ui.txtCrearFormato.text())
			self.ui.txtCrearFormato.setText("")
		return
		

	def aceptarFormatos(self):
		if self.ui.txtEditarFormato.text().length()>0:
			self.ui.lstFormatos.currentItem().setText(self.ui.txtEditarFormato.text())
			self.frmParent.campos.formatos[self.frmParent.campos.formatos_pos[self.ui.lstFormatos.currentRow()+1]] = self.frmParent.codifica(self.ui.txtEditarFormato.text())
		return

	def lstFormatos_click(self,item):
		try:
			self.ui.txtEditarFormato.setText(item.text())
		except:
			return
		

	#___________________________________________________________________________________
	#	Generos

	def llenaGeneros(self):		
		self.frmParent.campos.llenaddlGenero(self.ui.lstGeneros,'lst')		

	def lstGeneros_click(self,item):
		try:
			self.ui.txtEditarGenero.setText(item.text())
		except:
			return
		
	def aceptarGeneros(self):
		if self.ui.txtEditarGenero.text().length()>0:
			self.ui.lstGeneros.currentItem().setText(self.ui.txtEditarGenero.text())
			self.frmParent.campos.generos[self.frmParent.campos.generos_pos[self.ui.lstGeneros.currentRow()+1]] = self.frmParent.codifica(self.ui.txtEditarGenero.text())		
		return

	def eliminarGeneros(self):
		if self.ui.lstGeneros.currentRow()>=0:
			self.generos_eliminados.append(self.frmParent.campos.generos_pos[self.ui.lstGeneros.currentRow()+1])
			del self.frmParent.campos.generos[self.frmParent.campos.generos_pos[self.ui.lstGeneros.currentRow()+1]]
			self.ui.lstGeneros.takeItem(self.ui.lstGeneros.currentRow())
			self.ui.txtEditarGenero.setText("")
	
	def nuevoGenero(self):
		if self.ui.txtCrearGenero.text().length()>0:
			self.ui.lstGeneros.addItem(self.ui.txtCrearGenero.text())
			self.frmParent.campos.generos['n'+self.frmParent.codifica(self.ui.txtCrearGenero.text())] = self.frmParent.codifica(self.ui.txtCrearGenero.text())
			self.frmParent.campos.generos_pos[self.ui.lstGeneros.count()]='n'+self.frmParent.codifica(self.ui.txtCrearGenero.text())
			self.ui.txtCrearGenero.setText("")
		
		return


	#___________________________________________________________________________________
	#	Tipos

	def llenaTipos(self):
		self.frmParent.campos.llenaddlTipo(self.ui.lstTipos,'lst')

	def lstTipos_click(self,item):
		try:
			self.ui.txtEditarTipo.setText(item.text())
		except:
			return
		
	def aceptarTipos(self):
		if self.ui.txtEditarTipo.text().length()>0:
			self.ui.lstTipos.currentItem().setText(self.ui.txtEditarTipo.text())
			self.frmParent.campos.tipos[self.frmParent.campos.tipos_pos[self.ui.lstTipos.currentRow()+1]] = self.frmParent.codifica(self.ui.txtEditarTipo.text())
		return
	
	def eliminarTipos(self):
		if self.ui.lstTipos.currentRow()>=0:
			self.tipos_eliminados.append(self.frmParent.campos.tipos_pos[self.ui.lstTipos.currentRow()+1])
			del self.frmParent.campos.tipos[self.frmParent.campos.tipos_pos[self.ui.lstTipos.currentRow()+1]]
			self.ui.lstTipos.takeItem(self.ui.lstTipos.currentRow())
			self.ui.txtEditarTipo.setText("")
		return
	
	def nuevoTipo(self):
		if self.ui.txtCrearTipo.text().length()>0:
			self.ui.lstTipos.addItem(self.ui.txtCrearTipo.text())
			self.frmParent.campos.tipos['n'+self.frmParent.codifica(self.ui.txtCrearTipo.text())] = self.frmParent.codifica(self.ui.txtCrearTipo.text())
			self.frmParent.campos.tipos_pos[self.ui.lstTipos.count()]='n'+self.frmParent.codifica(self.ui.txtCrearTipo.text())
			self.ui.txtCrearTipo.setText("")	
		return

	#______________________________________________________________________________________________________
	#	Localizaciones
	
	def llenaLocalizaciones(self):
		self.frmParent.campos.llenaddlLocalizacion(self.ui.lstLocalizaciones,'lst')

	def lstLocalizaciones_click(self,item):
		try:
			self.ui.txtEditarLocalizacion.setText(item.text())
		except:
			return
		
	def aceptarLocalizaciones(self):
		if self.ui.txtEditarLocalizacion.text().length()>0:
			self.ui.lstLocalizaciones.currentItem().setText(self.ui.txtEditarLocalizacion.text())
			self.frmParent.campos.localizaciones[self.frmParent.campos.localizaciones_pos[self.ui.lstLocalizaciones.currentRow()+1]] = self.frmParent.codifica(self.ui.txtEditarLocalizacion.text())
		return
	
	def eliminarLocalizacion(self):
		if self.ui.lstLocalizaciones.currentRow()>=0:
			self.localizaciones_eliminadas.append(self.frmParent.campos.localizaciones_pos[self.ui.lstLocalizaciones.currentRow()+1])
			del self.frmParent.campos.localizaciones[self.frmParent.campos.localizaciones_pos[self.ui.lstLocalizaciones.currentRow()+1]]
			self.ui.lstLocalizaciones.takeItem(self.ui.lstLocalizaciones.currentRow())
			self.ui.txtEditarLocalizacion.setText("")
		return

	def nuevaLocalizacion(self):
		if self.ui.txtCrearLocalizacion.text().length()>0:
			self.ui.lstLocalizaciones.addItem(self.ui.txtCrearLocalizacion.text())
			self.frmParent.campos.localizaciones['n'+self.frmParent.codifica(self.ui.txtCrearLocalizacion.text())] = self.frmParent.codifica(self.ui.txtCrearLocalizacion.text())
			self.frmParent.campos.localizaciones_pos[self.ui.lstLocalizaciones.count()]='n'+self.frmParent.codifica(self.ui.txtCrearLocalizacion.text())
			self.ui.txtCrearLocalizacion.setText("")	
